#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

/**********************************************
Posicao do pivot na egpp
**********************************************/
int maxpos(double *a, int n, int dim)
{
  int i, nmax;

  for(i=0,nmax=0;i<n;i++)
    if(abs(a[nmax*dim])<abs(a[i*dim]))
      nmax=i;
  return nmax;
}


/*************************************************************
 Eliminacao de Gauss com Pivotagem Parcial ax=b
*************************************************************/
void egpp(int n, double *a, double *b, double *x, int *singular)
{
  int i, j, k, npiv;
  double baux, aux[n], mult;
  double *col;
  
  
  *singular=0;
  
  for(j=0;j<n-1;j++){
    col=a+n*j+j; /* posicao na coluna do pivot */
    npiv=maxpos(col, n-j, n); /* posicao do maximo da coluna */
    if(npiv!=0){ /* fazer troca */
      memcpy(aux, col, (n-j)*sizeof(double));
      memcpy(col, col+npiv*n, (n-j)*sizeof(double));
      memcpy(col+npiv*n, aux, (n-j)*sizeof(double));
      baux=b[j];
      b[j]=b[j+npiv];
      b[j+npiv]=baux;
    }
    for(i=1;i<n-j;i++){
      mult=-(*(col+i*n))/(*col);
      for(k=1;k<n-j;k++)
	*(col+i*n+k)=(*(col+k))*mult+(*(col+i*n+k));
      b[i+j]=b[j]*mult+b[i+j];
    }
  }

  /* calculate solution */

  for(i=n-1;i>=0;i--){ /* from bottom to top */
    x[i]=b[i];
    for(j=n-1;j>i;j--)
      x[i]-=x[j]*(*(a+i*n+j));
    if(!(*(a+i*n+i))){
      *singular=1;
      return;
    }
    x[i]/=(*(a+i*n+i));
  }


}

/*  
main()
{
  double a[]={ 80, 0, 30, 10, 0, 80, 10, 10, 16, 20, 60, 72, 4, 0, 0, 8};
  double b[]={ 40, 27, 31, 2};
  double x[4];
  int sing;

  egpp(4, a, b, x, sing);

  printf("singular %d\n", sing);

  printf("x=%f, %f, %f, %f\n", x[0], x[1], x[2], x[3]);

}

*/

