#include "sip_solver.h"

extern SIP_S sip_s;
extern SSO Sip_Opt;

double penaltylf(int nx, double *x, int nt, double *t, int nl, double *lag,
		 double miu, double *pt, double *cs, int dlevel, double *grad,
		 double *jac);
void gpenaltylf(int nx, double *x, int nt, double *t, int nl, double *lag,
		double miu, double *dx, double *fx, double *pt, double *cs,
		double *jac);
void larmijo(int nx, double *x0, double *dir, double *x1, double *grad,
	    double miu, int nl, double *lag);
void largo(int nx, double *x0, double *dir, double *x1, double *grad,
	  double miu, int nl, double *lag);
void lwolfe(int nx, double *x0, double *dir, double *x1, double *grad,
	    double miu, int nl, double *lag);


extern void set_h(double *h, int k, int nx, double *x1, double *x0,
		  double *g1, double *g0);
extern void get_dir(int nx, double *x, double *h, double *grad, double *dir);
extern void scale_dir(int nx, double *dir);
extern int pf_i_stop(int nx, double *x0, double *x1, double *g1, double pt);
extern int pf_o_stop(int nx, double *x0, double *x1, double *g1, double pt);
extern int pf_eps_stop(int nx, double *x0, double *x1);
extern double gxt(double *x, double *t, int j, int dlevel, double *grad,
		  double miu);
extern double gxtplus(double *x, double *t, int j, int dlevel, double *grad,
		      double miu);
extern double gxtplus2(double *x, double *t, int j, int dlevel, double *grad,
		       double miu);
extern double gxtepsilon(double *x, double *t, int j, int dlevel, double *grad,
			 double miu);
extern double gxtexpplus(double *x, double *t, int j, int dlevel, double *grad,
			 double miu);
extern double gxtexpepsilon(double *x, double *t, int j, int dlevel,
			    double *grad, double miu);
extern double gxtteo(double *x, double *t, int j, int dlevel, double *grad,
		     double miu);
extern double gxtexpteo(double *x, double *t, int j, int dlevel, double *grad,
			double miu);
extern double gxtexp1teo(double *x, double *t, int j, int dlevel, double *grad,
			 double miu);
extern double gxthart(double *x, double *t, int j, int dlevel, double *grad,
		      double miu);
extern double gxtgross(double *x, double *t, int j, int dlevel, double *grad,
		       double miu);

extern void printarray(double *a, int n);
extern void printmatrix(double *a, int n1, int n2);

extern void egpp(int n, double *a, double *b, double *x, int *singular);

extern void npoptn_(char *, int);
extern int npsol_(long *n, long *nclin, long *ncnln, long *nrowa,
        long *nrowuj, long *nrowr, double *a, double *bl, double *bu,
        void (*confun) (), void (*objfun) (), long *inform, long *iter,
        long *istate, double *c, double *ujac, double *clamda, double *objf,
        double *ugrad, double *r, double *x, long *iw, long *leniw,
        double *w, long *lenw);

double solve_pf(void);


