#include "sip_powell.h"
#include "sip_int.h"



void pfpowells()
{
  double init0[nxsip], init1[nxsip], miu, f0;
  int ko, tki;

  FILE *fp;

  memcpy(init0, X, nxsip*sizeof(double));
  memcpy(init1, X, nxsip*sizeof(double));

  miu=Sip_Opt.startmiu;

  tki=0; /* total internal iterations */

  for(ko=0;ko<Sip_Opt.maxitero;ko++){
    if(ko)
      miu*=Sip_Opt.miufactor;


    printf("STARTING INNER ITERATIONS ********** miu=%f\n", miu);
    powell(init1, miu, &tki);

    /* outer stopping criteria */
    if(pfpowell_o_stop(nxsip, init0, init1)){
      printf("OUTER STOPPING IN ITERATION ********* %d\n", ko+1);
      break;
    }
    memcpy(init0, init1, sizeof(double)*nxsip);
  }



  memcpy(X, init1, sizeof(double)*nxsip);
  printarray(init1, nxsip);

  fp=fopen("./results", "a+");
  f0=eval_sip(SIP_OBJVAL, 0, X, NULL, NULL, NULL, NULL, NULL);
  fprintf(fp, " & %d & %d & %d & %d & %d & %d & %.6f\\\\\n", tki, ko+1,
	  stats.nsip_objval, stats.nsip_objgrd, stats.nsip_contval,
	  stats.nsip_contgrd, f0);
  fclose(fp);

}


void powell(double *init, double miu, int *tki)
{
  double eta[nxsip*nxsip], xs[nxsip*(nxsip+1)], xspf[nxsip+1], f3;
  double cp, deltamax, delta;
  double tsample[ntsip], aux[nxsip];
  double pt, dprod;
  double s, sb, hquad[nxsip];
  int i, j, kext, mmax;


  identity(eta, nxsip);
  
  s=1;sb=1;

  memcpy(xs, init, sizeof(double)*nxsip);

  /* penalty value may have changed */
  xspf[0]=penaltyf(nxsip, &xs[0], ntsip, tsample, miu, &pt);

  hquad[0]=0;

  for(kext=1;kext<=Sip_Opt.powell_nmax;kext++){ /* external cycle */

    for(i=0; i<nxsip; i++){
      xspf[i+1]=quad(&xs[i*nxsip], xspf[i], &eta[i*nxsip], &xs[(i+1)*nxsip],
		     kext, &hquad[0], miu, s);

      /*
	printf("Old penalty %f, New penalty %f\n",
	penaltyf(nxsip, &xs[i*nxsip], ntsip, tsample, miu, &pt),
	penaltyf(nxsip, &xs[(i+1)*nxsip], ntsip, tsample, miu, &pt));
      */
    }
    
    /*    f2=penaltyf(nxsip, &xs[nxsip*nxsip], ntsip, tsample, miu, &pt);*/

    if(xspf[0]<xspf[nxsip])
      printf("PENALTY FUNCTION INCREASED 1\n");
    
    for(i=0;i<nxsip;i++)
      aux[i]=2*xs[nxsip*nxsip+i]-xs[i];

    f3=penaltyf(nxsip, aux, ntsip, tsample, miu, &pt);

    if(f3<xspf[0]){

      mmax=0;
      deltamax=xspf[0]-xspf[1];
      /*
	penaltyf(nxsip, &xs[0], ntsip, tsample, miu, &pt)
	-penaltyf(nxsip, &xs[nxsip], ntsip, tsample, miu, &pt);
      */
      
      for(i=1;i<nxsip;i++){
	delta=xspf[i]-xspf[i+1];

	/*penaltyf(nxsip, &xs[i*nxsip], ntsip, tsample, miu, &pt)
	  -penaltyf(nxsip, &xs[(i+1)*nxsip], ntsip, tsample, miu, &pt);
	*/
	if(delta>deltamax){
	  mmax=i;deltamax=delta;
	}
      }

      if((xspf[0]-2*xspf[nxsip]+f3)*pow((xspf[0]-xspf[nxsip]-deltamax),2.0)<(deltamax/2)*pow((xspf[0]-f3),2.0)){
	/*	printf("ETAS:\n");
		for(i=0;i<nxsip;i++)
		printarray(&eta[i*nxsip],nxsip);
		printf("\n\n");
		printf("Changing base, replacing eta %d deltamax=%f\n", mmax,
		deltamax);
	*/
	if(mmax!=nxsip-1){
	  for(i=mmax;i<nxsip;i++){
	    for(j=0;j<nxsip;j++)
	      eta[i*nxsip+j]=eta[(i+1)*nxsip+j];
	  }
	}
	
	dprod=0.0;
	for(i=0;i<nxsip;i++)
	  dprod+=pow((xs[nxsip*nxsip+i]-xs[i]),2.0);
	dprod=sqrt(dprod);

	for(i=0;i<nxsip;i++)
	  eta[(nxsip-1)*nxsip+i]=(xs[nxsip*nxsip+i]-xs[i])/dprod;

	/*	printf("ETAS:\n");
		for(i=0;i<nxsip;i++)
		printarray(&eta[i*nxsip],nxsip);
		printf("\n\n");
	*/
	
	
	xspf[nxsip]=quad(&xs[nxsip*nxsip],xspf[nxsip-1],&eta[(nxsip-1)*nxsip],
			 aux, kext, &hquad[0], miu, s);

	for(i=0;i<nxsip;i++)
	  xs[nxsip*nxsip+i]=aux[i];

	/*  f2=penaltyf(nxsip, &xs[nxsip*nxsip], ntsip, tsample, miu, &pt);*/

	if(xspf[0]<xspf[nxsip])
	  printf("PENALTY FUNCTION INCREASED 2\n");

      }
    }

    /*    printf("X: ");
	  printarray(&xs[nxsip*nxsip],nxsip);
	  printf("PF: %.12f\n", f2);
    */

    /* convergencia */

    if(fabs(xspf[0])<Sip_Opt.powell_epson){
      cp=Sip_Opt.powell_epson*fabs(xspf[0]);
    } else {
      cp=Sip_Opt.powell_epson;
    }

    if(fabs(xspf[0]-xspf[nxsip])<=cp){
      for(i=0;i<nxsip;i++){
	if(fabs(xs[i])>Sip_Opt.powell_epson){
	  cp=fabs(xs[i])*Sip_Opt.powell_epson;
	} else {
	  cp=Sip_Opt.powell_epson;
	}
	if(fabs(xs[i]-xs[nxsip*nxsip+i])>cp)
	  break;
      }
      if(i>=nxsip){
	for(i=0;i<nxsip;i++)
	  init[i]=xs[nxsip*nxsip+i];
	*tki+=kext;
	return;
      }
    }
           
    /*! nao convergiu*/
    s=minimum(sb, 0.4*sqrt(fabs(xspf[0]-xspf[nxsip])));

    for(i=0;i<nxsip;i++)
      xs[i]=xs[nxsip*nxsip+i];
    xspf[0]=xspf[nxsip];

  }


  printf("Iteration limit reached\n");
  for(i=0;i<nxsip;i++){
    init[i]=xs[i];
  }
}


/************************************************************************
DSC with quadratic interpolation
************************************************************************/
double quad(double *xk0, double fxk0, double *dir, double *xk1, double kquasi,
	    double *h, double miu, double factor)
{
  double alpha0, s, alpha;
  double alpha1, alpha2, alpha3, phi1, phi2, phi3, phi4;
  double A, B, C, D, am, bm, cm, dm;
  double teta1, teta2;
  double pt;
  double tsample[nxsip];
  int klocal, kext, i, cycle;
  
  cycle=0;
  
  /*  if(kquasi==1)*/
  /*    *h=0.1;*/
  if(*h<0)*h=- *h;
  if(*h<0.001)*h=0.001;
  if(*h>10)*h=10;
  
  alpha0=0.0;
  printf("Quad: h=%f\n", *h);
  printf("Quad: X:");
  printarray(xk0, nxsip);
  printf("Quad: Dir:");
  printarray(dir, nxsip);

  teta1=1E-3;
  teta2=1E-5;

  A=fxk0;


  for(kext=0;kext<150;kext++){

    for(i=0;i<nxsip;i++)
      xk1[i]=xk0[i]+(alpha0+ *h)*dir[i];
    B=penaltyf(nxsip, xk1, ntsip, tsample, miu, &pt);
    if(B>A){
      s=- *h; /* go to left  ? */
      for(i=0;i<nxsip;i++)
	xk1[i]=xk0[i]+(alpha0+s)*dir[i];
      C=penaltyf(nxsip, xk1, ntsip, tsample, miu, &pt);
      if(C>A){
	alpha1=alpha0+s;alpha2=alpha0;alpha3=alpha0-s;
	phi1=C;phi2=A;phi3=B;
	alpha=poli2(alpha1, alpha2, phi1, phi2, phi3);
	for(i=0;i<nxsip;i++)
	  xk1[i]=xk0[i]+alpha*dir[i];
	phi4=penaltyf(nxsip, xk1, ntsip, tsample, miu, &pt);

	/*printf("Quad: Interval used %f %f %f\n", alpha1, alpha2, alpha3);
	printf("Quad: Penalty  used %f %f %f\n", phi1, phi2, phi3);
	printf("Quad: New alpha=%f, new penalty %f\n", alpha, phi4);*/
	/* if phi2 is best then cycle with phi2 */
  	if(phi4<phi2){
	  if(fabs(phi2)>teta2){
	    if(fabs(phi2-phi4)<=teta1*fabs(phi2)){
	      printf("Quad: alpha=%f PF=%f\n",alpha, phi4);
	      *h=alpha;
	      return phi4; /* xk1 is our next point */
	    }
	  } else {
	    if(fabs(phi2-phi4)<=teta1){
	      printf("Quad: alpha=%f PF=%f\n",alpha, phi4);
	      *h=alpha;
	      return phi4;  /* xk1 is our next point */
	    } 
	  }
	} else {
	  alpha=alpha2;
	  phi4=phi2;
	  cycle++;
	  if(cycle>3){
	    for(i=0;i<nxsip;i++)
	      xk1[i]=xk0[i]+alpha*dir[i];
	    return phi4;
	  }
	}
	s=0; /* to cycle again */
      } else {
	B=C; /* go to left */
      }
    } else {
      s=*h;  /* go to right */
    }

    if(s){
      am=alpha0;
      bm=alpha0+s;
      for(klocal=0;klocal<10;klocal++){  /* cycle to left or right */
        s=2*s;cm=bm+s;
	for(i=0;i<nxsip;i++)
	  xk1[i]=xk0[i]+cm*dir[i];
	C=penaltyf(nxsip, xk1, ntsip, tsample, miu, &pt);
	if(C>=B)
	  break;
	/* C<=B */
	am=bm;A=B;
	bm=cm;B=C;
      }

      if(C>=B){ /* previous cycle stopped and parabola found */
	dm=0.5*(bm+cm);
	for(i=0;i<nxsip;i++)
	  xk1[i]=xk0[i]+dm*dir[i];
	D=penaltyf(nxsip, xk1, ntsip, tsample, miu, &pt);
	if(s<0){
	  if(D<B){
	    alpha1=cm;alpha2=dm;alpha3=bm;
	    phi1=C;phi2=D;phi3=B;
	  } else {
	    alpha1=dm;alpha2=bm;alpha3=am;
	    phi1=D;phi2=B;phi3=A;
	  }
	} else {
	  if(D<B){
	      alpha1=bm;alpha2=dm;alpha3=cm;
	      phi1=B;phi2=D;phi3=C;
	  } else {
	    alpha1=am;alpha2=bm;alpha3=dm;
	    phi1=A;phi2=B;phi3=D;
	  }
	}
	alpha=poli2(alpha1, alpha2, phi1, phi2, phi3);
      } else { /* parabola not found, and limit exceeded */
	if(s<0){ /* left limit exceeded */
/*      	  alpha=-1E-2; */
	  printf("Quad: Left limit exceeded\n");
	} else { /* right limit exceeded */
/*      	  alpha=1E-2; */
	  printf("Quad: Right limit exceeded\n");  
	}
	alpha=cm;
	*h=cm;
  	for(i=0;i<nxsip;i++)
  		xk1[i]=xk0[i]+alpha*dir[i];
  	printf("Quad: alpha=%f PF=%f, pt=%f\n",alpha, C, pt);
  	return (penaltyf(nxsip, xk1, ntsip, tsample, miu, &pt));
      }

      /* stopping criteria */
      for(i=0;i<nxsip;i++)
	xk1[i]=xk0[i]+alpha*dir[i];
      phi4=penaltyf(nxsip, xk1, ntsip, tsample, miu, &pt);
      if(fabs(phi2)>teta2){
	if(fabs(phi2-phi4)<=teta1*fabs(phi2)){
	  printf("Quad: alpha=%f PF=%f\n",alpha, phi4);
	  /*	  for(i=0;i<nxsip;i++)
		  xk1[i]=xk0[i]+alpha*factor*dir[i];*/
	  *h=alpha;
	  return phi4; /* stop */
	}
      } else {
	if(fabs(phi2-phi4)<=teta1){
	  printf("Quad: alpha=%f PF=%f\n",alpha, phi4);
	  /*	  for(i=0;i<nxsip;i++)
		  xk1[i]=xk0[i]+alpha*factor*dir[i];*/
	  *h=alpha;
	  return phi4; /* stop */
	}
      }

    }

    alpha0=alpha;
    A=phi4;
    *h=*h/2;
  }
  printf("Quad: Reached exterior limit, h=%f alpha=%.12f\n", *h, alpha);
  for(i=0;i<nxsip;i++)
    xk1[i]=xk0[i]+alpha*dir[i];
  printf("Quad: New h=%f\n", *h);
  *h=alpha;
  return phi4;
}



double poli2(double alpha1, double alpha2, double phi1, double phi2,
	     double phi3)
{
  double alpha, quociente;

  quociente=2*(phi3-2*phi2+phi1);
  if(quociente==0){
    alpha=phi2;
  } else {
    alpha=alpha2-(((alpha2-alpha1)*(phi3-phi1))/quociente);
  }

  return alpha;
}



/*******************************
check outer stopping criteria
*******************************/
int pfpowell_o_stop(int nx, double *x0, double *x1)
{
  int i;
  double aux1, aux2, aux3;
  static int zero=0;


  printf("Checking stopping criteria\n");
  printarray(x0, nxsip);
  printarray(x1, nxsip);

  aux1=aux2=0;
  for(i=0;i<nx;i++){
    aux1+=pow((x1[i]-x0[i]),2.0);
    aux2+=pow(x1[i],2.0);
  }
  
  if(sqrt(aux2)<=Sip_Opt.zero){
    aux3=sqrt(aux1);
  } else {
    aux3=sqrt(aux1)/sqrt(aux2);
  }
  
  if(aux3>Sip_Opt.pf_preco){
        printf("Not stopping in outer iteration %f\n", aux3);
	return 0;
  }

  if(!memcmp(x0, x1, nx*sizeof(double))){
    if(zero++>4){
      printf("\n\n*******************************************************\n");
      printf("* NO PROGRESS IN SOLUTION. SOLUTION MAY BE UNFEASIBLE *\n");
      printf("*******************************************************\n\n\n");
      return 1;
    }
  }


  /*
  if(pt>Sip_Opt.pf_preco){
        printf("Not stopping in outer iteration pt=%f\n", pt);
	return 0;
  }
  */

  return 1;
}
