#include "sip_teo.h"
#include "sip_int.h"



void penaltyfs_teo()
{
  double tsample[ntsip];
  double dir[nxsip];
  double h[nxsip*nxsip];
  double x0[nxsip], x1[nxsip], g1[nxsip], g0[nxsip], y[nxsip];
  double f0, f1, dummy;
  int ko, ki, tki;
  int i;
  double miu, pt, norg;  /* penalty parameter */

  FILE *fp; /* for results file */


  miu=Sip_Opt.startmiu;
  Sip_Opt.pf_epsilon=1e-18;

  tki=0;
  memcpy(x1, X, nxsip*sizeof(double)); /* x1 with initial guess */
  gpenaltyf(nxsip, x1, ntsip, tsample, miu, g1, &f1, &pt);
  /*    f1=penaltyf(nxsip, x1, ntsip, tsample, miu, &pt, NO_DERIV, NULL); */

  for(ko=0;ko<Sip_Opt.maxitero;ko++){


    /* y with initial guess for inner iter */
    memcpy(y, x1, nxsip*sizeof(double));

    printf("STARTING INNER ITERATIONS ********** miu=%f\n", miu);
    
    for(ki=0;ki<Sip_Opt.maxiteri;ki++){ /* Quasi-Newton inner iteration */

      /* Set Hessian inverse */
      set_h(h, ki, nxsip, x1, x0, g1, g0);
      
      /*      printf("Hessian inverse\n");
	      printmatrix(h, nxsip, nxsip);*/
    
    
      memcpy(x0, x1, nxsip*sizeof(double));
      memcpy(g0, g1, nxsip*sizeof(double));
      f0=f1;

      get_dir(nxsip, x0, h, g0, dir);

      printf("X: ");
      printarray(x0, nxsip);
      printf("Penalty %f\n", f0);
      printf("Gradient: ");
      printarray(g0, nxsip);
      printf("Direction: ");
      printarray(dir, nxsip);

      if(Sip_Opt.ScaleDir)
	scale_dir(nxsip, dir);

      switch (Sip_Opt.linesearch){
      default:
	printf("Unknown LineSearch\nUsing Armijo\n");
      case ARMIJO:
	armijo(nxsip, x0, dir, x1, g0, miu);
	break;
      case ARGO:
	argo(nxsip, x0, dir, x1, g0, miu);
	break;
      case WOLFE:
	wolfe(nxsip, x0, dir, x1, g0, miu);
	break;
      };

      gpenaltyf(nxsip, x1, ntsip, tsample, miu, g1, &f1, &pt);
      
      printf("Penalty terms %f %f constraints %f\n", f0, f1, pt);
      
      
      /* inner stopping criteria */
      if(pf_i_stop(nxsip, x0, x1, g1, pt)){
	printf("INNER STOPPING IN ITERATION ********* %d\n", ki+1);
	break;
      }
    }

    tki+=ki+1;

    if(fabs(pt)<1e-4){
      break; 
      Sip_Opt.pf_epsilon/=10;
      if(Sip_Opt.pf_epsilon<1e-7)
	break;
    } else {
      miu*=Sip_Opt.miufactor;
      if(miu>1e+9)
	break;
      /* Get new penalty value, miu has changed */
      gpenaltyf(nxsip, x1, ntsip, tsample, miu, g1, &f1, &pt);
    }
    

    /* outer stopping criteria */
    /*      if(pf_o_stop(nxsip, y, x1, g1, pt)){ */
    /*        printf("OUTER STOPPING IN ITERATION ********* %d\n", ko+1); */
    /*        break; */
    /*      } */
  }

  printf("STOPPING IN ITERATION ********* %d\n", ko+1);  
  memcpy(X, x1, nxsip*sizeof(double));
  printf("Solution found\n");
  printarray(X, nxsip);
  printf("Penalty function value\n");
  printf("%f\n",f1);

/*  penaltyf(nxsip, x1, ntsip, tsample, miu, &pt, NO_DERIV, NULL)); */


  fp=fopen("./results", "a+");
  f0=eval_sip(SIP_OBJVAL, 0, X, NULL, NULL, NULL, NULL, NULL);

  printf("Gradient of penalty:\n");
  printarray(g1, nxsip);

  norg=0.0;
  for(i=0;i<nxsip;i++)
    norg+=g1[i]*g1[i];
  norg=sqrt(norg);

  dummy=eval_sip(SIP_OBJGRD, 0, x1, NULL, g1, NULL, NULL, NULL);

  printf("Gradient of objective:\n");
  printarray(g1, nxsip);
  

  /*  fprintf(fp, " & %d & %d & %d & %d & %d & %d & %.4e & %.4e & %.2e\\\\\n",
	  tki, ko+1, stats.nsip_objval, stats.nsip_objgrd, stats.nsip_contval,
	  stats.nsip_contgrd, f0, f1, norg);
  */
  fprintf(fp, " & %d & %d & %d & %d & %.6e \\\\\n",
	  tki, ko+1, stats.nsip_pfval, stats.nsip_gpfval, f0);
  fclose(fp);

}

