#include "solver.h"
#include <time.h>
/*#include <stdlib.h> include in sip_solver.h */


extern SIP_S sip_s;
extern Mesh Sip_Mesh;
extern Mesh T_Set;

/*  extern double halton(); */
/*  extern void egpp(); */



/*  void sip_iguess(double *x) */
/*  { */
/*    int npts;  number of points per infinite constraint */
/*    int i, j, k, res, sing; */
/*    double *a, *b, *tmpa, *tmpb, *Y, *T, *RT; */

/*    a=mymalloc(nxsip*nxsip*sizeof(double)); */
/*    b=mymalloc(nxsip*sizeof(double)); */
/*    Y=mymalloc(nxsip*sizeof(double)); */
/*    memset(Y, 0, nxsip*sizeof(double)); */
/*    T=mymalloc(ntsip*sizeof(double)); */
/*    RT=mymalloc(ntsip*sizeof(double)); */

/*    npts=nxsip/ntsipc; dimensao do problem por numero de restricoes infinitas*/
/*    if(npts<1) */
/*      npts=1; */

/*    tmpa=a; */
/*    tmpb=b; */
/*    for(i=0;i<nxsip;){ */
/*      res=(int)(i/npts); */
/*      for(j=0;j<npts && i<nxsip;j++,i++){ */
/*        for(k=0;k<ntsip;k++) */
/*  	T[k]=TBL[i]+halton(i+1, k)*(TBU[i]-TBL[i]); */
/*        eval_sip(SIP_CONTGRD, res, Y, T, tmpa, RT, NULL, NULL); */
/*        tmpa+=nxsip; */
/*      } */
/*      *tmpb++=eval_sip(SIP_CONTVAL, res, Y, T, NULL, NULL, NULL, NULL); */
/*    } */

/*    egpp(nxsip, a, b, x, sing); */

/*    if(sing){ */
/*      printf("Matrix da aproximacao e' singular\n"); */
/*      for(i=0;i<nxsip;i++) */
/*        x[i]=1; */
/*    } */

/*    printf("Ponto inicial: "); */
/*    for(i=0;i<nxsip-1;i++) */
/*      printf("%f,", x[i]); */
/*    printf("%f\n", x[nxsip-1]); */

/*    free(a); */
/*    free(b); */
/*    free(Y); */
/*    free(T); */
/*    free(RT); */
/*  } */
      


void sip_iguess(double *x)
{
  double *h, *min, *max;
  int i;

  h=mymalloc(ntsip*sizeof(double));

  for(i=0;i<ntsip;i++)
    h[i]=(TBU[i]-TBL[i])/5; /* 5 points per dimension */


  min=mymalloc(ntsip*sizeof(double));
  max=mymalloc(ntsip*sizeof(double));

  for(i=0;i<ntsip;i++){
    if(TBL[i]<0 && TBU[i]>0){
      min[i]=0; max[i]=maximum(fabs(TBL[i]), fabs(TBU[i]));
    } else {
      if(TBL[i]>=0){
	min[i]=TBL[i]; max[i]=TBU[i];
      } else {
	min[i]=-TBU[i]; max[i]=-TBL[i];
      }
    }
  }

  /* Min norm will be the point with lower coordinates*/
  Sip_Mesh.Min_Norm=norm2(ntsip, min);

  /* Max norm will be the point with upper coordinates*/
  Sip_Mesh.Max_Norm=norm2(ntsip, max);

  free(min);
  free(max);

  /* for the moment I will have HASH_SIZE hash pointers */
  Sip_Mesh.nHash=HASH_SIZE;
  Sip_Mesh.AmpHash=(Sip_Mesh.Max_Norm-Sip_Mesh.Min_Norm)/HASH_SIZE;

  /* allocate pointers to point struct */
  Sip_Mesh.Mesh=mymalloc(Sip_Mesh.nHash*sizeof(Points *));
  memset(Sip_Mesh.Mesh, 0, Sip_Mesh.nHash*sizeof(Points *));

  Sip_Mesh.nPoints=0;
  

  fill_mesh(h);

  T_Set.Min_Norm=Sip_Mesh.Min_Norm;
  T_Set.Max_Norm=Sip_Mesh.Max_Norm;
  T_Set.nHash=HASH_SIZE;
  T_Set.AmpHash=Sip_Mesh.AmpHash;
  T_Set.Mesh=mymalloc(T_Set.nHash*sizeof(Points *));
  memset(T_Set.Mesh, 0, T_Set.nHash*sizeof(Points *));
  T_Set.nPoints=0;


  fill_T();

#if defined __linux__ || defined linux
  srandom((unsigned)time(NULL));
#else
  srand((unsigned)time(NULL));
#endif

  for(i=0;i<nxsip;i++)
#if defined __linux__ || defined linux
    x[i]=((double)random())/RAND_MAX; /* random number between 0 and 1 */
#else
    x[i]=((double)rand())/RAND_MAX; /* random number between 0 and 1 */
#endif

  /*  printarray(x, nxsip);*/

  solve_nlp();

  /*printarray(x, nxsip);*/

  free_mesh(&Sip_Mesh);
  free_mesh(&T_Set);

  free(Sip_Mesh.Mesh);
  free(T_Set.Mesh);
}

  
    

