###############################################################################
# Objective: Linear
# Constraints: Linear
###############################################################################
#  Design of FIR filters
#   As described by A.W. Potchinkov
#	"Design of optimal linear phase FIR filters by a semi-infinite
#	    programming technique"
#	 in Signal Processing 58 (1997) 165-180
#	
#   Design 3
#    Coded by A. Ismael F. Vaz 04/07/2000  aivaz@ci.uminho.pt
#    University of Minho, Portugal
###############################################################################
# ATTENTION: The problems is not well coded
###############################################################################
param pi := atan(1)*4;
param N := 129;
param R := 64;


var x {0..R};
var d;
var t{1..2};




minimize fx:
	d;

subject to t1:
	-(sum {n in 0..R} (x[n]*cos(t[1]*n)))+1-d <=0;

subject to t2:
	-10*(sum {n in 0..R} (x[n]*cos(t[2]*n)))-d <=0;

subject to t3:
	(sum {n in 0..R} (x[n]*cos(t[1]*n)))-1-d <=0;

subject to t4:
	10*(sum {n in 0..R} (x[n]*cos(t[2]*n)))-d <=0;

subject to bound1:
	0 <= t[1] <=0.2*pi;

subject to bound2:
	0.24*pi <= t[2] <=pi;


# solve problem
# don't forget to write .col and .row files
option nsips_auxfiles rc;
#option reset_initial_guesses 1; # don't want a initial guess
option solver nsips;
solve;


display x;
display fx;
