####################################################################
# Objective: Quadratic
# Constraints: Linear
#
# Sample problem in the user manual. This example was made to test
#  the sipampl2 MATLAB function. It makes no sense to solve it.
#
# aivaz@dps.uminho.pt 13/11/2002
####################################################################

var x {1..2};
# t var name must start with a t
var t {1..2};

#objective function
minimize fx: x[1]^2*x[1]^3+x[2]^2;

# constraint depends on t, so name must start with a t
subject to tcons1:
  x[1]*t[1]+x[2]*t[2]^2 <=  0;
# constraint does not depends on t, so name must not start with a t
# inequality constraint
subject to cons1:
  -10  <= x[1]^3*x[2]^2+x[2]^2 <=  10;
# equality constraint
subject to cons2:
  x[1]+x[2]^3 =  5;
# inequality constraint
subject to cons3:
  -10  <= x[1]+2*x[2]*x[1]^3 <=  10;
subject to tcons2:
  x[1]^4*t[1]+x[2]^2*x[1]*t[2]^2 <=  0;
subject to cons4:
  -10  <= x[1]^4+2*x[2]*x[1]^3 <=  10;
subject to tcons3:
  x[1]^4*t[1]^2+x[2]^2*x[1]*t[2]^2 <=  0;
# bounds on t var
# ampl presolver will remove this constraint
subject to bounds1:
  0 <= t[1] <= 1;
subject to bounds2:
  -1 <= t[2] <= 1;

subject to xbounds:
  0 <= x[2] <= 10;



###################
# End of Problem  #
###################

# don't forget to write .col and .row files
option nsips_auxfiles rc;
# this problem have no initial guess (starting point)
option reset_initial_guesses 1;
# change solver
option solver nsips;
# solve problem
solve;

##################
# Solution found #
##################
printf "Solution found\n";
display x;
display fx;
