#include "math.h"
#include "errno.h"
#ifndef fint
#ifndef Long
#include "arith.h"	/* for Long */
#ifndef Long
#define Long long
#endif
#endif
#define fint Long
#endif
#ifndef real
#define real double
#endif
#ifdef __cplusplus
extern "C" {
#endif
 fint funcom_[13] = {
	3 /* nvar */,
	1 /* nobj */,
	1 /* ncon */,
	3 /* nzc */,
	0 /* densejac */,

	/* objtype (0 = minimize, 1 = maximize) */

	1,

	/* colstarts */
	1,
	2,
	3,
	4,

	/* rownos */
	1,
	1,
	1 };

 real boundc_[1+6+2] /* Infinity, variable bounds, constraint bounds */ = {
		1.7e308,
		-1.7e308,
		1.7e308,
		-1.7e308,
		1.7e308,
		0.,
		1.,
		-1.7e308,
		0.};

 real x0comn_[3] = {
		2.,
		0.,
		0. };

 static real pd[11];
static real old_x[3];
static int xkind = -1;

 static int
xcheck(real *x)
{
	real *x1 = old_x, *xe = x + 3;
	errno = 0;
	if (xkind >= 0) {
		while(*x++ == *x1++)
			if (x == xe)
				return 0;
		--x, --x1;
		}
	do *x1++ = *x++;
		while(x < xe);
	xkind = 0;
	return 1;
	}
 real
feval_(fint *nobj, fint *needfg, real *x, real *g)
{
	real v[3], rv;
	fint wantfg = *needfg;
	if (xcheck(x) && wantfg == 2)
		wantfg = 3;

	if (wantfg & 1) {

  /***  objective ***/

	pd[8] = x[0] * x[0];
	pd[9] = x[0] + x[0];
	v[0] = 0.3333333333333333 * pd[8];
	v[1] = x[1] * x[1];
	pd[10] = x[1] + x[1];
	v[2] = v[0] + v[1];
	rv = v[2] + 0.5*x[0];
	;}

	if (wantfg & 2) {
	g[1] = pd[10];
	g[0] = 0.3333333333333333*pd[9] + 0.5;
	}

	return rv;
}

 void
ceval_(fint *needfg, real *x, real *c, real *J)
{
	real v[3], dv[2];
	real t1;
	fint wantfg = *needfg;
	if (xcheck(x) && wantfg == 2)
		wantfg = 3;

	if (wantfg & 1) {

  /***  constraint 1  ***/

	pd[0] = x[0] * x[0];
	pd[1] = x[0] + x[0];
	pd[2] = x[2] * x[2];
	pd[3] = x[2] + x[2];
	v[0] = pd[0] * pd[2];
	v[1] = 1. - v[0];
	v[0] = v[1] * v[1];
	pd[4] = v[1] + v[1];
	pd[5] = x[2] * x[2];
	pd[6] = x[2] + x[2];
	v[1] = x[0] * pd[5];
	v[2] = -v[1];
	v[0] += v[2];
	v[2] = x[1] * x[1];
	pd[7] = x[1] + x[1];
	v[1] = -v[2];
	v[0] += v[1];
	t1 = v[0] + x[1];
	c[0] = t1;
	;}
	if (wantfg & 2) {

   /*** derivatives for constraint 1 ***/

	J[1] = -pd[7] + 1.;
	J[0] = -pd[5];
	J[2] = -x[0]*pd[6];
	dv[0] = -pd[4]*pd[0];
	dv[1] = -pd[4]*pd[2];
	J[2] += dv[0]*pd[3];
	J[0] += dv[1]*pd[1];
	}
}
#ifdef __cplusplus
	}
#endif
