#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "solver.h"

extern STATS stats;
extern SIP_S sip_s;
extern SSO Sip_Opt;


extern void printarray(double *a, int n);
extern void printmatrix(double *a, int n1, int n2);

extern void set_h(double *h, int k, int nx, double *x1, double *x0,
		  double *g1, double *g0);
extern int pf_o_stop(int nx, double *x0, double *x1, double *g1, double pt);

extern double penaltyf(int nx, double *x, int nt, double *t, double miu,
		       double *pt, int dlevel, double *grad);
extern void armijo(int nx, double *x0, double *dir, double *x1, double *grad,
		   double miu);


void dual_objfun(long *MODE, long *N, double *Xn, double *F, double *G,
	       long *NSTATE);
void dual_confun(long *MODE, long *NCNLN, long *N, long *NROWJ, long *NEEDC,
	       double *X0, double *C, double *CJAC, long *NSTATE);

extern void npoptn_(char *, int);
extern int npsol_(long *n, long *nclin, long *ncnln, long *nrowa,
        long *nrowuj, long *nrowr, double *a, double *bl, double *bu,
        void (*confun) (), void (*objfun) (), long *inform, long *iter,
        long *istate, double *c, double *ujac, double *clamda, double *objf,
        double *ugrad, double *r, double *x, long *iw, long *leniw,
        double *w, long *lenw);

#define Inf 1e+21

void get_dir_dualQP(double *dir);
void Integral_gxtgrd(double *Xn, double *aux);
double Integral_gxt(double *Xn);
double Integral_unit(double *Xn);
double dual_gxt(double *x, double *t, int j, int dlevel, double *grad,
		double miu);
double unit(double *x, double *t, int j, int dlevel, double *grad,
	    double miu);
extern double gxt(double *x, double *t, int j, int dlevel, double *grad,
		  double miu);
extern double gxtplus2(double *x, double *t, int j, int dlevel, double *grad,
		  double miu);

double Integral_gxtdgrd(double *Xn, double *d);

double dual_pf(int nx, double *x, int nt, double *t, double miu, double *pt);

void dual_armijo(int nx, double *x0, double *dir, double *x1, double *grd,
		 double miu);
double dual_pterm(int nx, double *x, int nt,double *t,int dlevel, double *gmf);

int dual_stop(int nx, double *x0, double *x1, double *g1);
