#include "solver.h"

extern SIP_S sip_s;
extern SSO Sip_Opt;
extern STATS stats;

enum {
  PUSH,
  POP,
  POP_PHI,
  CLEAN
};

double mylog(double x);

void get_pc_dir(int nx, double *x, double *s, int nl, double *lag,
		  double *hss, double *fgd, double *jac, double *laggdx,
		  double *laggdl, double *term, double miu, double *dir);
void get_dual_dir(int nx, double *x, double *s, int nl, double *lag,
		  double *hss, double *fgd, double *jac, double *laggdx,
		  double *laggdl, double *term, double miu, double *dir);
void get_primal_dir(int nx, double *x, double *s, int nl, double *lag,
		    double *hss, double *fgd, double *jac, double *laggdx,
		    double *laggdl, double *term, double miu, double *dir);
void get_dir_intpkkt_tmp(int nx, double *x, double *s, int nl, double *lag,
			 double *hss, double *fgd, double *jac, double *laggdx,
			 double *laggdl, double *term, double miu, double *dir);
int push_pop_sol(int op, int nx, double *x, int nl, double *s, double *lag,
		 double *dir, double *alpha, double *beta, double *phi,
		 double *hss);
int armijo_intpkkt(int nx, double *x0, double *s0, int nl, double *lag0,
		    double *dir, double miu, double *x1, double *s1,
		    double *lag1, double *hss, int reset);
void armi_bakry(int nx, double *x0, double *s0, int nl, double *lag0,
		double *dir, double miu, double *x1, double *s1, double *lag1);
void armijo_intdual(int nx, double *x0, double *s0, int nl, double *lag0,
		     double *dir, double miu, double *x1, double *s1,
		     double *lag1);
double intpkkt_merit(int nx, double *x0, double *s0, int nl, double *lag0,
		     double miu, double beta, double *gradx, double *grads,
		     double *fgd, double *rho, double *jac);
double intpbakry_merit(int nx, double *x, double *s, int nl, double *lag);
double intdual_merit(int nx, double *x, double *s, int nl, double *lag);
double lagintpkkt(int nx, double *x, int nl, double *lag, double *s, int nt,
		  double *t, double miu, int dlevel,  double *fgd,
		  double *laggdx, double *laggdl, double *jac, double *term,
		  double *f);
int int_stop(int nx, int nl, double *fgd, double *lag, double *s,
	     double *jac, double *term, double *primal, double *dual);
void second_order(int nx, int nl, double *w, double *jac, double *rho);
void GetInitialGuess(int nx, double *x, double *x1, int nl, double *s1,
		     double *lag1);




extern int pf_eps_stop(int nx, double *x0, double *x1);
extern void set_hss(double *hss, int k, int nx , double *x1, double *x0,
	     double *g1, double *g0);
extern void identity(double *h, int nx);
extern void set_h(double *h, int k, int nx, double *x1, double *x0,
		  double *g1, double *g0);
extern int pf_i_stop(int nx, double *x0, double *x1, double *g1, double pt);
extern int pf_o_stop(int nx, double *x0, double *x1, double *g1, double pt);
extern void scale_dir(int nx, double *dir);
extern void egpp(int n, double *a, double *b, double *x, int *singular);
extern void cholesky(int n, double *a, double *b, double *x, int *singular);
extern void mod_cholesky(int n, double *a, double *b, double *x, double eps,
			 int *singular);
extern void zero_cholesky(int n, double *a, double *b, double *x, double eps,
			  int *singular);
extern double gxtteo(double *x, double *t, int j, int dlevel, double *grad,
		     double miu);
extern double gxtepsilon(double *x, double *t, int j, int dlevel, double *grad,
			 double miu);

extern void printarray(double *a, int n);
extern void printmatrix(double *a, int n1, int n2);
