/*******************************************************************
Copyright (C) 2000 Universidade do Minho

umsip = University of Minho Semi-Infinite Programming Interface

Ismael Vaz -- aivaz@ci.uminho.pt
********************************************************************/

#ifndef NSIPS_included
#define NSIPS_included

void usage(int argc, char** argv);
void solver(void);
double sip_eval(int mode, int n, double *X, double *T, double *RX, double *RT, double *RXT, long *nerror);
void printarray(double *a, int n);
void printmatrix(double *a, int n1, int n2);

enum {
  SIP_OBJVAL=1,
  SIP_OBJGRD=2,
  SIP_OBJHES=3,
  SIP_CONVAL=4,
  SIP_JACVAL=5,
  SIP_CONXVAL=6,
  SIP_CONTVAL=7,
  SIP_CONXGRD=8,
  SIP_CONTGRD=9,
  SIP_CONXHES=10,
  SIP_CONTHES=11,
};

typedef struct {
  int nsip_objval;
  int nsip_objgrd;
  int nsip_objhes;
  int nsip_conval;
  int nsip_jacval;
  int nsip_pfval; /* penalty function evalutation */
  int nsip_gpfval;/* gradient penalty function evalutation */
  int nsip_lag; /* lagrangian */
  int nsip_mer; /* merit function */
  int nsip_conxval;
  int nsip_contval;
  int nsip_conxgrd;
  int nsip_contgrd;
  int nsip_conxhes;
  int nsip_conthes;
  int nnlpc;
  int nnlp;
} STATS;

#endif
